VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10065
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   571
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   671
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox Picture1 
      Height          =   495
      Left            =   360
      ScaleHeight     =   435
      ScaleWidth      =   1155
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
   Begin VB.PictureBox Picture2 
      Height          =   495
      Left            =   360
      ScaleHeight     =   435
      ScaleWidth      =   1155
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1215
      Left            =   1800
      TabIndex        =   2
      Top             =   360
      Width           =   255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' Schnelle Helligkeitsnderung eines Bildes per AlphaBlend

' Copyright  2007 by Zardoz

Option Explicit

' GdiAlphaBlend: Windows NT/2000/XP/Vista: Included in Windows 2000 and later.
Private Declare Function GdiAlphaBlend Lib "gdi32" (ByVal hdcDest As Long, _
  ByVal XDest As Long, ByVal YDest As Long, ByVal WidthDest As Long, _
  ByVal HeightDest As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, _
  ByVal ySrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long, _
  ByVal Blendfunc As Long) As Long

' AlphaBlend: Windows NT/2000/XP/Vista: Included in Windows 2000 and later.
' AlphaBlend: Windows 95/98/Me: Included in Windows 98 and later.

' Private Declare Function AlphaBlend Lib "msimg32" (ByVal hdcDest As Long, ByVal XDest As Long, ByVal YDest As Long, _
    ByVal WidthDest As Long, ByVal HeightDest As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
    ByVal WidthSrc As Long, ByVal HeightSrc As Long, ByVal Blendfunc As Long) As Long

Private SW As Long ' Bildbreite
Private SH As Long ' Bildhhe

Private Sub Form_Load()
  Dim Dat1 As String
  Dim TmpPic As StdPicture
  
  Dat1 = App.Path & "\DemoPic1.jpeg" ' Pfad eines Bildes
  ' Pfad prfen
  If Dir$(Dat1) = "" Then
    MsgBox "Datei nicht gefunden:" & vbCr & Dat1, vbExclamation + vbOKOnly
    Unload Me
    Exit Sub
  End If
  ' Einstellungen Form
  Me.ScaleMode = vbPixels
  Me.BackColor = RGB(100, 180, 255)

  Set TmpPic = LoadPicture(Dat1) ' Bild laden
  ' Einstellungen Picturebox2, dient als Bildspeicher
  With Picture2
    .Visible = False
    .BorderStyle = vbBSNone
    .ScaleMode = vbPixels
    SW = CLng(.ScaleX(TmpPic.Width, vbHimetric)) ' Bildbreite
    SH = CLng(.ScaleY(TmpPic.Height, vbHimetric)) ' Bildhhe
    .Move 0, 0, SW, SH ' Gre anpassen
    .AutoRedraw = True
    .PaintPicture TmpPic, 0, 0
  End With
  Set TmpPic = LoadPicture() ' Speicher freigeben
  
  ' Einstellungen Picturebox1, dient zur Anzeige des Bildes
  With Picture1
    .ScaleMode = vbPixels
    .BorderStyle = vbBSNone
    .Move 8, 8, SW, SH
    .AutoRedraw = True
  End With
  ' Einstellungen fr Scrollbar
  With VScroll1
    .Min = -255
    .Max = 255
    .SmallChange = 1
    .LargeChange = 30
    .TabStop = False
    .Value = 0
    .ZOrder vbBringToFront
  End With
  Call VScroll1_Scroll ' Startbild
End Sub

Private Sub Form_Resize()
  ' Scrollbar positionieren
  If Me.WindowState <> vbMinimized Then VScroll1.Move Me.ScaleWidth - 32, 0, 24, 550
End Sub

Private Sub VScroll1_Change()
  ' Event durchreichen
  Call VScroll1_Scroll
End Sub

Private Sub VScroll1_Scroll()
  ' Bild berechnen
  Dim Wert As Long
  
  Wert = VScroll1.Value
  With Picture1
    .BackColor = IIf(Wert < 0, vbWhite, vbBlack)
    Wert = 255 - Abs(Wert) ' Alpha-Wert errechnen
    
    ' Aufruf fr GdiAlphaBlend:
    Call GdiAlphaBlend(.hDC, 0, 0, SW, SH, Picture2.hDC, 0, 0, SW, SH, &H10000 * Wert)
    
    ' Aufruf fr AlphaBlend:
    ' Call AlphaBlend(.hDC, 0, 0, SW, SH, Picture2.hDC, 0, 0, SW, SH, &H10000 * Wert)
    
    .Refresh ' Auffrischen erzwingen
  End With
  ' Alpha-Wert ausgeben
  Me.Caption = Space$(5) & "Alpha = " & Wert
End Sub
